#include <Stepper.h>
#include <A4988.h>
#include <BasicStepperDriver.h>
#include <DRV8825.h>
#include <DRV8834.h>
#include <DRV8880.h>
#include <MultiDriver.h>
#include <SyncDriver.h>
#include <Servo.h>

#define MOTOR_STEPS 200

#define PWM_pin 9
#define DIR_X 5
#define DIR_Y 6
#define DIR_Z 7
#define STEP_X 2
#define STEP_Y 3
#define STEP_Z 4

BasicStepperDriver stepperX(MOTOR_STEPS, DIR_X, STEP_X);
BasicStepperDriver stepperY(MOTOR_STEPS, DIR_Y, STEP_Y);
BasicStepperDriver stepperZ(MOTOR_STEPS, DIR_Z, STEP_Z);
Servo servo;
#define ENDSTOP_X 1
#define ENDSTOP_Y 2
#define ENDSTOP_Z 3
boolean ESX = false;
boolean ESY = false;
boolean ESZ = false;


////////////7777
const byte numChars = 32;
char receivedChars[numChars];
char tempChars[numChars];        // temporary array for use when parsing
///////////7
int integerFromPC = 0;
int integerFromPC1 = 0;
int integerFromPC2 = 0;
int integerFromPC3 = 0;
char messageFromPC[numChars] = {0};
boolean newData = false;
//////////////////// 
SyncDriver controller(stepperX, stepperY,stepperZ);

void setup() {
  Serial.begin(115200);
  servo.attach(PWM_pin);
    stepperX.begin(60, 1);
    stepperY.begin(60, 1);
    stepperZ.begin(60, 1);

///Calibración con los endstops
while(ESX && ESY && ESZ){
  bool ESX = digitalRead(ENDSTOP_X);
  if(ESX)controller.move(-1,0,0);
  delay(30);
  bool ESY = digitalRead(ENDSTOP_Y);
  if(ESY)controller.move(0,-1,0);
  delay(30);
  bool ESZ = digitalRead(ENDSTOP_Z);
  if(ESZ)controller.move(0,0,-1);
  delay(30);

}
}
void loop() {
    recvWithStartEndMarkers();
    if (newData == true) {
        strcpy(tempChars, receivedChars);
        parseData();
        showParsedData(); 
        if (messageFromPC=="m"){
          controller.move(integerFromPC,integerFromPC1,integerFromPC2);
          }
        else if (messageFromPC=="p"){
          servo.write(integerFromPC);
    unsigned wait_time_micros = controller.nextAction();
     while(wait_time_micros > 0){
      //esperando
      }
      Serial.println('#');
    }

}
}
void recvWithStartEndMarkers() {
    static boolean recvInProgress = false;
    static byte ndx = 0;
    char startMarker = '<';
    char endMarker = '>';
    char rc;

    while (Serial.available() > 0 && newData == false) {
        rc = Serial.read();

        if (recvInProgress == true) {
            if (rc != endMarker) {
                receivedChars[ndx] = rc;
                ndx++;
                if (ndx >= numChars) {
                    ndx = numChars - 1;
                }
            }
            else {
                receivedChars[ndx] = '\0'; // terminate the string
                recvInProgress = false;
                ndx = 0;
                newData = true;
            }
        }

        else if (rc == startMarker) {
            recvInProgress = true;
        }
    }
}

//============




void parseData() {      // split the data into its parts

    char * strtokIndx; // this is used by strtok() as an index

    strtokIndx = strtok(tempChars,",");      // get the first part - the string
    strcpy(messageFromPC, strtokIndx); // copy it to messageFromPC

    strtokIndx = strtok(NULL, ","); // this continues where the previous call left off
    integerFromPC = atoi(strtokIndx);     // convert this part to an integer
    strtokIndx = strtok(NULL, ","); // this continues where the previous call left off
    integerFromPC1 = atoi(strtokIndx);     // convert this part to an integer
    strtokIndx = strtok(NULL, ","); // this continues where the previous call left off
    integerFromPC2 = atoi(strtokIndx);      // convert this part to an integer
    strtokIndx = strtok(NULL, ","); // this continues where the previous call left off
    integerFromPC3 = atoi(strtokIndx);      // convert this part to an integer


}

void showParsedData() {
    Serial.print("codigo ");
    Serial.println(messageFromPC);
    Serial.print("Integer0 ");
    Serial.println(integerFromPC);
    Serial.print("Integer1");
    Serial.println(integerFromPC1);
    Serial.print("Integer2");
    Serial.println(integerFromPC2);
    Serial.print("Integer3");
    Serial.println(integerFromPC3);
}
